;a gusty generator
;by smkdan

;SET TO THE SPRITE NUMBER GUSTY USES
SPRITE_NO = $14		;gusty assumed $14, change to whatever you please

;$00 = few
;$01 = lots
;$02 = plenty
GENERATE_RATE = $02

;set to $01 to enable either.  If both are enabled, they randomly come from each side
GENERATE_LEFT = $01
GENERATE_RIGHT = $01

dcb "INIT"
	RTL

dcb "MAIN"
	PHB
	PHK
	PLB
	JSR Run
	PLB
	RTL	;also nothing

MASK	dcb $7F,$3F,$1F

Run
	LDX #GENERATE_RATE	;user specified generation rate
	LDA $14		;frame counter...
	AND MASK,x
	BNE Return	;only every X frames

	JSL $02A9E4	;fetch a free sprite slot
	BMI Return	;return if negative / none avaliable
	
	TYX		;sprite slot into X
	LDA #$08
	STA $14C8,x	;normal status for sprite
	LDA #SPRITE_NO	;gusty sprite number
	STA $7FAB9E,x	;custom sprite to generate

	JSL $07F7D2	;init sprite tables

	LDA #GENERATE_RIGHT
	ASL A
	ORA #GENERATE_LEFT
	CMP #$01
	BNE Next1
	JSR Gen_l	;01 = left
	BRA Create	
Next1
	CMP #$02
	BNE Next2	;02 = right
	JSR Gen_r
	BRA Create
Next2
	CMP #$03
	BNE Return	;no other possible scenario
	JSR Gen_lr	;03 = left and right, and roll into Create	

Create	
	JSL $0187A7	;tweaker byte loading, 24bit address in $00
		
	LDA #$8C	;set as custom sprite, extra bit set to indicate the generator created it.
	STA $7FAB10,x

	PHK		;push program bank
	PER.w #$0002	;PC relative, puts return address
	JML ($0000)	;24bit indirect to INIT	routine

Return		
	RTS

Gen_r
	LDA $1A		;xscroll low    
	CLC                       
        ADC #$FF	;place sprite beyond display                
	STA $E4,X	;xpos low       
	LDA $1B		;scroll high    
	ADC #$00                
	STA $14E0,x	;xpos high

	JSL $01ACF9	;random number             
	AND #$7F                
	ADC #$20                
	ADC $1C 	;y scroll low   
	AND #$F0                
	STA $D8,X	;place sprite at one of 16 rows       
	LDA $1D		;y scroll high   
	ADC #$00                
	STA $14D4,X	;transfer carry

	INC $157C,x	;go left

	RTS
Gen_l
	LDA $1A		;xscroll low  
	SEC 
	SBC #$28	;40px to hide the sprite before coming form the left side of the screen               
	STA $E4,X	;xpos low       
	LDA $1B		;scroll high
	SBC #$00	;sub possible carry                  
	STA $14E0,x	;xpos high

	JSL $01ACF9	;random number             
	AND #$7F                
	ADC #$20                
	ADC $1C 	;y scroll low   
	AND #$F0                
	STA $D8,X	;place sprite at one of 16 rows       
	LDA $1D		;y scroll high   
	ADC #$00                
	STA $14D4,X	;transfer carry

	STZ $157C,x	;go right
	
	RTS
Gen_lr
	JSL $01ACF9	;GetRand
	AND #$01
	BEQ Gen_l	;either one for left
	BRA Gen_r	;or right depending on return value from random